VERSION 8000; ; 8413
* -----------------------------------------------------------------------------
* @filedoc
* @file Achse_Attributendern.CSX
* @brief Fortlaufendes ndern der Achsattribute 
* 
* Achsbezeichnung, -kode und Subtyp knnen gendert werden.
* Die neuen Daten werden sofort gespeichert.
* Der Abbruch erfolgt ber ESC. 
* Die bis dahin genderten nderungen bleiben wirksam.
* Ein Undo ist nur fr den gesamten Vorgang mglich.
*
* -----------------------------------------------------------------------------
* Copyright (C) IB&T
* 
* Gewhrleistung und Nutzung
* 
* Die Nutzung des Skriptes erfolgt stets auf eigene Gefahr. IB&T bernimmt keine
* Gewhr dafr, dass die Nutzung dieses Skriptes zu Ihrem gewnschten Ergebnis
* fhrt. Da CardScripte vorhandene Projektdaten durch Direktzugriff auf die
* jeweiligen Datenbanken auch ohne weitere Sicherheitsabfragen unbemerkt verndern
* oder lschen knnen, erfordert eine Nutzung entsprechende Kenntnisse und groe
* Sorgfalt. IB&T haftet nicht fr eventuell entstehende Datenverluste und
* Folgeschden, die durch die Nutzung von CardScripten entstehen.
*
* -----------------------------------------------------------------------------
* @author TRI
* @endfiledoc
* -----------------------------------------------------------------------------
*       1  7.01.09 TRI erstellt
*       2 26.01.09 TRI um Achskode erweitert, Dialog umgestellt
*    8300 25.05.09 JH  Version fr 8.3 bereitgestellt
*                      - Achstypen und Subtypen als Klartext integriert 
*                      - Dialogwahl fr Achskode ergnzt
*    8413 22.10.12 CK  Dialog erneuert
* @history
* -----------------------------------------------------------------------------
* --- Vereinbarungen ----------------------------------------------------------

BILDSCHIRM GRAFIK                                | gibt Meldungen im Arbeitsprotokoll aus
* --- Explizite Deklarationen -------------------------------------------------
SYMBOLE /ALIGNMENTSYS/ AchsSys                   | Symbol fr das System der Achsen
SYMBOLE /ALIGNMENT/ Achse1                       | Symbol fr die Achse
SYMBOLS /GENERALCHOICE/  Achstabelle;SubTypTabelle
SYMBOLS * Ret;AchsNr;AchsKode;!Kode;AchsTyp;!AchsTyp;AchsSubTyp;!AchsSubTyp
* --- Ausfhrungen ------------------------------------------------------------
* Systemobjekt
AchsSys = Project.GetAlignmentSys()

* Achse whlen
AchsNr =  ACHS_WAHL(0)
* Achse mit Bezeichnung
Achse1 = AchsSys.GetAlignment(AchsNr)
IF Achse1 == $NULL THEN STOP
!AchsBezeich = Achse1.GetDescription()                | Achsbezeichnung 
* Achskode mit Bezeichnung
AchsKode = Achse1.GetCode()                           | Achskode
!Kode = Achse1.GetCodeDescription()                   | Achskodebezeichnung
* Achstyp mit Bezeichnung
AchsTyp = Achse1.GetType()
!AchsTyp = !TypeBez_C(AchsTyp)   
* Achssubtyp 
AchsSubTyp = Achse1.GetSubType()                       | liefert den Achssubtyp

 * GeneralChoice-Tabelle fr Achssubtyp erzeugen
SubTypTabelle = NEWOBJECT /GENERALCHOICE/ 
SubTypTabelle.SetCaption("AchsSubTyp") 
SubTypTabelle.SetSortMode(0) 
SubTypTabelle.SetHeadLine("AchsSubtyp"; "Beschreibung")
* Achstyp: Strae, unbestimmt
IF AchsTyp == 0 @ AchsTyp == 1 THEN
  SubTypTabelle.AddItem("0";"unbestimmt")
  SubTypTabelle.AddItem("1";"Hauptachse")
  SubTypTabelle.AddItem("2";"Fahrbahnrand")
  SubTypTabelle.AddItem("3";"Kreisfahrbahn - uerer Rand")
  SubTypTabelle.AddItem("4";"Tropfen")
  SubTypTabelle.AddItem("5";"linke Dreiecksinsel")
  SubTypTabelle.AddItem("6";"Rechtsabbieger")
  SubTypTabelle.AddItem("7";"rechte Dreiecksinsel")
  SubTypTabelle.AddItem("8";"Rechtseinbieger")
  SubTypTabelle.AddItem("9";"Fahrbahnteiler (Kreisverkehr)")
  SubTypTabelle.AddItem("10";"einfache Eckausrundung (Kreisverkehr)")
  SubTypTabelle.AddItem("11";"Eckausrundung (Kreisverkehr)")
  SubTypTabelle.AddItem("12";"Fahrstreifenbegrenzung")
  SubTypTabelle.AddItem("13";"Leitlinie")
END IF
* Achstyp: Eisenbahn, Straenbahn
IF AchsTyp == 2 @ AchsTyp == 5 THEN
  SubTypTabelle.AddItem("0";"unbestimmt")
  SubTypTabelle.AddItem("1";"Kilometrierungslinie")
  SubTypTabelle.AddItem("2";"Gleisachse")
  SubTypTabelle.AddItem("3";"Bahnhofsgleis")
  SubTypTabelle.AddItem("4";"Gleisverbindung")
  SubTypTabelle.AddItem("5";"linkes Streckengleis")
  SubTypTabelle.AddItem("6";"rechtes Streckengleis")
END IF
  *Achstyp: Kanal
IF AchsTyp == 3 THEN
  SubTypTabelle.AddItem("0";"unbestimmt")
  SubTypTabelle.AddItem("1";"Achse mit Knickpunkten")
  SubTypTabelle.AddItem("2";"Achse mit kleinen Radien")
  SubTypTabelle.AddItem("3";"Achse mit Schachtradien")
END IF
  
  *Achstyp: Magnetbahn
IF AchsTyp == 4 THEN
  SubTypTabelle.AddItem("0";"unbestimmt")
  SubTypTabelle.AddItem("1";"Kilometrierungslinie")
  SubTypTabelle.AddItem("2";"Spur, allgemein")
  SubTypTabelle.AddItem("3";"linke Spur")
  SubTypTabelle.AddItem("4";"rechte Spur")
  SubTypTabelle.AddItem("5";"berleitverbindung")
  SubTypTabelle.AddItem("6";"Nebenspur")
END IF
  * Achstyp: Wasserstrae, Deich, Hilfsachse
IF AchsTyp == 6 @ AchsTyp == 8 THEN
  SubTypTabelle.AddItem("0";"unbestimmt")
END IF
* Dialog
SYMBOLS /DLG_WINDOW/    Dialog                                                                        | Dialogfenster
SYMBOLS /DLG_FRAME/     Rahmen1                                                                       | Rahmen 
SYMBOLS /DLG_TEXT/      DF_AchsBezeich;DF_Achstypbez
SYMBOLS /DLG_NUMBER/    DF_Achse; DF_AchsTyp;DF_Subtyp
SYMBOLS /DLG_CODELINE/  DF_Achskode
SYMBOLS /MY_SUBTYPWAHL/ DF_SubTypBez

Dialog = NewObject /DLG_WINDOW/                        | Anlegen des Dialogfensters
Dialog.SetCaption("Attribute einer Gleisachse")                         | berschrift des Fensters

Rahmen1 = Dialog.CreateFrame(0;"")    | Rahmen 
Rahmen1.SetSize(130) 

*Dialogfelder
* gewhlte Achse (passiv)
DF_Achse = NewObject /DLG_NUMBER/
DF_Achse.SetLabel("Achse:                 ")
DF_Achse.SetValue(AchsNr)
DF_Achse.SetSize(7)
DF_Achse.SetActive(0)
Rahmen1.AddField(DF_Achse)
* Achsbezeichnung 
DF_AchsBezeich = NewObject /DLG_TEXT/
DF_AchsBezeich.SetText(!AchsBezeich)
DF_AchsBezeich.SetSize(42)
DF_AchsBezeich.AppendRight()
Rahmen1.AddField(DF_AchsBezeich)
* Achskode mit Bezeichnung 
DF_Achskode = NewObject /DLG_CODELINE/
DF_Achskode.SetLabel("Kode:                  ")
DF_Achskode.SetDart(10)
DF_Achskode.SetCode(AchsKode)
Rahmen1.AddField(DF_Achskode)
* Achstyp (passiv)
DF_AchsTyp = NewObject /DLG_NUMBER/
DF_AchsTyp.SetLabel("Typ:                   ")
DF_AchsTyp.SetValue(AchsTyp)
DF_AchsTyp.SetActive(0)
DF_AchsTyp.SetSize(7)
Rahmen1.AddField(DF_AchsTyp)
* Achstypbezeichnung (passiv)
DF_Achstypbez = NewObject /DLG_TEXT/
DF_Achstypbez.SetText(!AchsTyp)
DF_Achstypbez.SetSize(42)
DF_Achstypbez.AppendRight()
DF_Achstypbez.SetActive(0)
Rahmen1.AddField(DF_Achstypbez)
* Subtyp 
DF_Subtyp = NewObject /DLG_NUMBER/
DF_Subtyp.SetGeneralChoice(SubTypTabelle)
DF_Subtyp.SetValue(AchsSubTyp)
DF_Subtyp.SetLabel("SubTyp:                ")
DF_Subtyp.SetSize(7)
Rahmen1.AddField(DF_Subtyp)
* Subtypbezeichnung (passiv)
DF_SubtypBez = NewObject /MY_SUBTYPWAHL/
DF_SubtypBez.SetBezug(DF_Subtyp)
DF_SubtypBez.SetSize(38)
DF_SubtypBez.AppendRight()
DF_SubtypBez.SetActive(0)
Rahmen1.AddField(DF_SubtypBez)

* Dialog ausfhren
Ret = Dialog.DoDialog()
IF Ret THEN
  Project.OpenEditProcess()                  | Undo-Vorgang ffnen
  !AchsBezeich = DF_AchsBezeich.GetText()
  Achse1.SetDescription(!AchsBezeich)
  AchsKode= DF_Achskode.GetCode()
  Achse1.SetCode(AchsKode)
  AchsTyp = DF_AchsTyp.GetValue()
  AchsSubTyp = DF_Subtyp.GetValue()
  Achse1.SetType(AchsTyp;AchsSubTyp)
  Project.CloseEditProcess("Achsattribute gendert")
END IF
STOP
* -----------------------------------------------------------------------------
* @class /MY_SUBTYPWAHL/
* @brief <Textfeld fr SubTyp mit Aktualisierung aus Subtyp-Auswahl>
* @ingroup
* @author CK
* @endclass
CLASS /MY_SUBTYPWAHL/; /DLG_Text/
  SYMBOLS /DLG_NUMBER/ m_Typ;m_SubTyp 
* ---------------------------
  FUNCTION SetBezug: {/DLG_NUMBER/}  Subtyp
    m_SubTyp = SubTyp
    $Base.AddObserveField(Subtyp)
    Update()
  END FUNCTION 
* ---------------------------
  FUNCTION {long} NotifyField: {/DLG_FIELD/} Feld
    Update()
  END FUNCTION 
* ---------------------------
  FUNCTION Update:
    SYMBOLS * AchsTyp;AchsSubTyp;!AchsSubTyp 
    m_Typ = DF_AchsTyp
    AchsTyp = m_Typ.GetValue()
    AchsSubTyp = m_SubTyp.GetValue()
    IF AchsTyp == 0 @ AchsTyp == 1 THEN
      IF AchsSubTyp == 0 THEN !AchsSubTyp = "unbestimmt"
      IF AchsSubTyp == 1 THEN !AchsSubTyp = "Hauptachse"
      IF AchsSubTyp == 2 THEN !AchsSubTyp = "Fahrbahnrand"
      IF AchsSubTyp == 3 THEN !AchsSubTyp = "Kreisfahrbahn - uerer Rand"
      IF AchsSubTyp == 4 THEN !AchsSubTyp = "Tropfen"
      IF AchsSubTyp == 5 THEN !AchsSubTyp = "linke Dreiecksinsel"
      IF AchsSubTyp == 6 THEN !AchsSubTyp = "Rechtsabbieger"
      IF AchsSubTyp == 7 THEN !AchsSubTyp = "rechte Dreiecksinsel"
      IF AchsSubTyp == 8 THEN !AchsSubTyp = "Rechtseinbieger"
      IF AchsSubTyp == 9 THEN !AchsSubTyp = "Fahrbahnteiler (Kreisverkehr)"
      IF AchsSubTyp == 10 THEN !AchsSubTyp = "einfache Eckausrundung (Kreisverkehr)"
      IF AchsSubTyp == 11 THEN !AchsSubTyp = "Eckausrundung (Kreisverkehr)"
      IF AchsSubTyp == 12 THEN !AchsSubTyp = "Fahrstreifenbegrenzung"
      IF AchsSubTyp == 13 THEN !AchsSubTyp = "Leitlinie"
    END IF
    IF AchsTyp == 2 @ AchsTyp == 5 THEN
      IF AchsSubTyp == 0 THEN !AchsSubTyp = "unbestimmt"
      IF AchsSubTyp == 1 THEN !AchsSubTyp = "Kilometrierungslinie"
      IF AchsSubTyp == 2 THEN !AchsSubTyp = "Gleisachse"
      IF AchsSubTyp == 3 THEN !AchsSubTyp = "Bahnhofsgleis"
      IF AchsSubTyp == 4 THEN !AchsSubTyp = "Gleisverbindung"
      IF AchsSubTyp == 5 THEN !AchsSubTyp = "linkes Streckengleis"
      IF AchsSubTyp == 6 THEN !AchsSubTyp = "rechtes Streckengleis"
    END IF
    IF AchsTyp == 3 THEN
      IF AchsSubTyp == 0 THEN !AchsSubTyp = "unbestimmt"
      IF AchsSubTyp == 1 THEN !AchsSubTyp = "Achse mit Knickpunkten"
      IF AchsSubTyp == 2 THEN !AchsSubTyp = "Achse mit kleinen Radien"
      IF AchsSubTyp == 3 THEN !AchsSubTyp = "Achse mit Schachtradien"
    END IF
    IF AchsTyp == 4 THEN
      IF AchsSubTyp == 0 THEN !AchsSubTyp = "unbestimmt"
      IF AchsSubTyp == 1 THEN !AchsSubTyp = "Kilometrierungslinie"
      IF AchsSubTyp == 2 THEN !AchsSubTyp = "Spur, allgemein"
      IF AchsSubTyp == 3 THEN !AchsSubTyp = "linke Spur"
      IF AchsSubTyp == 4 THEN !AchsSubTyp = "rechte Spur"
      IF AchsSubTyp == 5 THEN !AchsSubTyp = "berleitverbindung"
      IF AchsSubTyp == 6 THEN !AchsSubTyp = "Nebenspur"
    END IF
    IF AchsTyp == 6 @ AchsTyp == 8 THEN
      IF AchsSubTyp == 0 THEN !AchsSubTyp = "unbestimmt"
    END IF
    $Base.SetText(!AchsSubTyp)  
  END FUNCTION
END CLASS

* -----------------------------------------------------------------------------
FUNKTION !TypeBez_C: Typ
  SYMBOLE * !Typ
  WENN Typ == 0 DANN !Typ = "unbestimmt"
  WENN Typ == 1 DANN !Typ = "Strae"
  WENN Typ == 2 DANN !Typ = "Eisenbahn"
  WENN Typ == 3 DANN !Typ = "Kanal"
  WENN Typ == 4 DANN !Typ = "Magnetbahn"
  WENN Typ == 5 DANN !Typ = "Straenbahn"
  WENN Typ == 6 DANN !Typ = "Wasserstrae"
  WENN Typ == 7 DANN !Typ = "Deich"
  WENN Typ == 8 DANN !Typ = "Hilfsachse"
  ZURCK !Typ
ENDE FUNKTION

